﻿using SlideOverKit;
using Syncfusion.SfGauge.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace GaugePage
{
    public class GaugePage : MenuContainerPage
    {
        public GaugePage(GroupReward r, int currentPage, int totalPages)
        {
            var sponsor = new Label()
            {
                Text = r.SponsorInfo.SponsorName,
                HorizontalTextAlignment = TextAlignment.Center,
            };

            var progressGauge = new SfCircularGauge()
            {
                WidthRequest = 225,
                HeightRequest = 225,
                BackgroundColor = Color.Transparent,
            };
            progressGauge.Headers.Add(new Header()
            {
                Text = "REWARD POINTS",
                ForegroundColor = Color.White,
                Position = new Point(.5, .3),
            });
            progressGauge.Headers.Add(new Header()
            {
                Text = (r?.CurrentEarnedPoints.ToString() ?? "0"),
                ForegroundColor = Color.White,
                Position = new Point(.5, .5),
            });
            progressGauge.Headers.Add(new Header()
            {
                Text = "OUT OF " + (r?.SponsorInfo?.PointTarget.ToString() ?? "0"),
                ForegroundColor = Color.White,
                Position = new Point(.5, .7),
            });
            var range = new Range()
            {
                StartValue = 0,
                Color = Color.Yellow,
                Thickness = 14,
                EndValue = Convert.ToDouble(r.CurrentEarnedPoints),
            };
            var scale = new Scale()
            {
                StartValue = 0,
                EndValue = Convert.ToDouble(r?.SponsorInfo?.PointTarget),
                StartAngle = 270,
                SweepAngle = 360,
                RimColor = Color.Red,
                RimThickness = 18,
                ShowLabels = false,
                ShowTicks = false,
            };
            scale.Ranges.Add(range);
            progressGauge.Scales.Add(scale);

            var gaugeLayout = new StackLayout
            {
                Margin = new Thickness(0, 20, 0, 0),
                Spacing = 10,
                BackgroundColor = Color.Transparent,
                Padding = new Thickness(0),
                HorizontalOptions = LayoutOptions.Center,
                VerticalOptions = LayoutOptions.FillAndExpand,
            };
            gaugeLayout.Children.Add(sponsor);
            gaugeLayout.Children.Add(progressGauge);

            TapGestureRecognizer PageTapGesturRecognizer = new TapGestureRecognizer();
            PageTapGesturRecognizer.Tapped += (async (o2, e2) =>
            {
                await Navigation.PushAsync(new TestPage());
            });
            gaugeLayout.GestureRecognizers.Add(PageTapGesturRecognizer);

            Content = gaugeLayout;
        }
    }
}
